﻿Imports System
Imports System.Resources
Imports System.Drawing
Imports System.Collections.ObjectModel
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.OleDb.OleDbConnection
Imports Microsoft.TeamFoundation.Client
Imports Microsoft.TeamFoundation.Framework.Common
Imports Microsoft.TeamFoundation.Framework.Client
Imports Microsoft.TeamFoundation.Common
Imports Microsoft.TeamFoundation.VersionControl.Client
Imports System.Globalization
Imports System.Threading

'this program is created to assist the tfs aministrator on:
'- changing a tfs project name
'- changing the description of that project
'- reporting the members or groups of that project

Public Class MainPage

    'main page of the of the administration program for Team Foundation Server

    Friend Structure Servers
        Dim TfsServer As String
        Dim TfsData As String
        Dim TfsVersion As String
    End Structure

    'http://msdn.microsoft.com/en-us/library/bb286958.aspx

    Private serverName As String
    Private ProjectCollection As String
    Private ProjectName As String
    Private NewName As String

    Private StartUp As Boolean = True

    Private serverBool1 As Boolean
    Private serverBool2 As Boolean

    Dim int As Integer = 0
    Dim int2 As Integer = 0

    Dim maxCollection As Integer = 0
    Dim maxProject As Integer = 0
    Dim start As Boolean = False

    Private Descript(,) As String

    Private Nselection As String
    Private Version As String

    Private Champs As New ArrayList
    Private CPNames As New ArrayList

    Public langFra As Boolean = False
    Dim LocRM As New ResourceManager("RenamingTool.Resource", GetType(MainPage).Assembly)

    Dim tfsUri As Uri
    Dim collectionNodes As ReadOnlyCollection(Of CatalogNode)
    Dim projectNodes As ReadOnlyCollection(Of CatalogNode)
    Dim configurationServer As TfsConfigurationServer

    Friend Server As New SortedList(Of String, Servers)

    Private Sub txtServerName_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtServerName.TextChanged
        'if the user changes anything in the textbox, 
        'it will clear all of the information that is displayed about tfs server.
        serverBool1 = False
        TreeView1.Nodes.Clear()

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'on start up of the program:
        '- all textbox on the screen will be reset
        '- reads an external file that carries the information of the tfs server and its database server
        initialize()
        ReadingFile()
        cmbItem()
    End Sub
    Private Sub initialize()
        'clears all information on the display
        txtServerName.Text = ""
        txtDataServer.Text = ""
        txtDescription.Text = ""
    End Sub

    Private Sub CloseToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CloseToolStripMenuItem1.Click
        'closes the program
        Dim dialog As DialogResult = MessageBox.Show(LocRM.GetString("CloseScreen.Message"), _
                                    LocRM.GetString("CloseScreen.text"), _
                                    MessageBoxButtons.YesNo, MessageBoxIcon.None,
                                    MessageBoxDefaultButton.Button1)
        If (dialog = Windows.Forms.DialogResult.Yes) Then
            Me.Close()
        End If

    End Sub


    Private Sub btnCheckServer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCheckServer.Click
        'checks if all server informations are correct
        start = False
        serverName = txtServerName.Text
        checkdata()
        FillTreeView(serverName)

    End Sub


    Public Function splitingLast(ByVal change As String) As String

        'this function returns the collection name 
        'ex: [TFSServer]\DefaultCollection = DefaultCollection
        'ex2: //http:/[TFSServer]/DefaultCollection = DefaultCollection

        Dim local As String() = change.Split(New Char() {"\"c})
        Dim hyperlink As String() = change.Split(New Char() {"/"c})

        Dim part As String

        If (local.Length = 1) Then
            part = hyperlink(hyperlink.Length - 1)
        Else
            part = local(local.Length - 1)
        End If

        Return part

    End Function

    Private Sub checkdata()
        'a random sql queries to ensure that the database server the user puts in the textbox is valid

        Dim connectionsql As String
        Dim querysql As String
        Try
            connectionsql = "Data Source=" & txtDataServer.Text & ";Initial Catalog=Tfs_Configuration;Integrated Security=True"
            querysql = "Select * from [dbo].[tbl_CatalogResource]"
            Dim myConnection As New SqlConnection(connectionsql)
            Dim myCommand As New SqlCommand(querysql)
            myCommand.Connection = myConnection
            myConnection.Open()
            myCommand.ExecuteReader()
            myCommand.Connection.Close()

            serverBool2 = True
        Catch ex As Exception
            MessageBox.Show(LocRM.GetString("Error_DatabaseServer"), _
            "Alert", _
            MessageBoxButtons.OK, _
            MessageBoxIcon.Exclamation, _
            MessageBoxDefaultButton.Button1)
            serverBool2 = False
        End Try

    End Sub

    Private Sub txtDataServer_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtDataServer.TextChanged

        'if the user changes the information in this textbox,
        'it will errase all information added in the treeview

        serverBool2 = False
        TreeView1.Nodes.Clear()
    End Sub

    Public Sub FillTreeView(ByVal sArgs As String)

        TreeView1.Nodes.Clear()
        CPNames.Clear()

        If (serverBool2) Then
            Try
                int = 0
                'getting the uri to tfs through the server-level
                tfsUri = New Uri("http://" & sArgs & ":8080/tfs")
                TreeView1.Nodes.Add(sArgs)
                TreeView1.Nodes(0).Tag = "Server"
                configurationServer = TfsConfigurationServerFactory.GetConfigurationServer(tfsUri)
                ' Get the catalog of team project collections
                Dim gVar As Guid() = New Guid() {CatalogResourceTypes.ProjectCollection}
                collectionNodes = configurationServer.CatalogNode.QueryChildren(gVar, False, CatalogQueryOptions.None)

                ' List the team project collections
                For Each collectionNode In collectionNodes
                    int2 = 0
                    Dim collectionId As Guid = New Guid(collectionNode.Resource.Properties("InstanceID"))
                    Dim teamProjectCollection As New TfsTeamProjectCollection(tfsUri)
                    teamProjectCollection = configurationServer.GetTeamProjectCollection(collectionId)
                    TreeView1.Nodes(0).Nodes.Add(teamProjectCollection.Name)
                    TreeView1.Nodes(0).Nodes(int).Text = splitingLast(teamProjectCollection.Name)
                    TreeView1.Nodes(0).Nodes(int).Tag = "Collection"
                    TreeView1.Nodes(0).Nodes(int).ImageIndex = 1
                    TreeView1.Nodes(0).Nodes(int).SelectedImageIndex = 1
                    CPNames.Add(splitingLast(teamProjectCollection.Name))

                    ' Get a catalog of team projects for the collection
                    Dim hVar As Guid() = New Guid() {CatalogResourceTypes.TeamProject}

                    projectNodes = collectionNode.QueryChildren(hVar, False, CatalogQueryOptions.None)
                    ' List the team projects in the collection
                    For Each projectNode In projectNodes
                        TreeView1.Nodes(0).Nodes(int).Nodes.Add(projectNode.Resource.DisplayName)
                        TreeView1.Nodes(0).Nodes(int).Nodes(int2).Tag = "Project"
                        TreeView1.Nodes(0).Nodes(int).Nodes(int2).ForeColor = Color.Navy
                        TreeView1.Nodes(0).Nodes(int).Nodes(int2).ImageIndex = 2
                        TreeView1.Nodes(0).Nodes(int).Nodes(int2).SelectedImageIndex = 2
                        CPNames.Add(projectNode.Resource.DisplayName)

                        'resize the String list to enter the description
                        If (start = False) Then
                            countCollectionAndProjects()
                            start = True
                        End If

                        'enters the description in the list
                        Descript(int, int2) = (projectNode.Resource.Description)

                        int2 = int2 + 1
                    Next
                    int = int + 1
                Next
                TreeView1.ExpandAll()
                serverBool1 = True
                StartUp = False
            Catch ex As Exception
                MessageBox.Show(LocRM.GetString("Error_TfsServer"), _
                "Alert", _
                MessageBoxButtons.OK, _
                MessageBoxIcon.Exclamation, _
                MessageBoxDefaultButton.Button1)
                serverBool1 = False
            End Try
        End If
    End Sub
    Public Function getServerNameFromServer() As String
        'gets the server name from the treeview
        getServerNameFromServer = TreeView1.SelectedNode.Text
        Return getServerNameFromServer
    End Function
    Public Function getCollectionNameFromCollection() As String
        'gets the Collection name from the treeview
        getCollectionNameFromCollection = TreeView1.SelectedNode.Text
        Return getCollectionNameFromCollection
    End Function
    Public Function getServerNameFromCollection() As String
        'gets the server name from the treeview
        getServerNameFromCollection = TreeView1.SelectedNode.Parent.Text
        Return TreeView1.SelectedNode.Parent.Text
    End Function
    Public Function getProjectName() As String
        'gets the project name from the treeview
        getProjectName = TreeView1.SelectedNode.Text
        Return getProjectName
    End Function
    Public Function getCollectionName() As String
        'gets the Collection name from the treeview
        getCollectionName = TreeView1.SelectedNode.Parent.Text
        Return getCollectionName
    End Function
    Public Function getServerName() As String
        'gets the Server name from the treeview
        getServerName = TreeView1.SelectedNode.Parent.Parent.Text
        Return getServerName
    End Function
    Public Function getDataTierName() As String
        getDataTierName = txtDataServer.Text
        Return getDataTierName
    End Function
    Public Function getSelection() As String
        getSelection = Nselection
        Return getSelection
    End Function
    Public Function getVersion() As String
        getVersion = Version
        Return getVersion
    End Function
    Public Function getAllNames() As ArrayList
        'gets the list of all the projects and collection name
        Dim AllNames As New ArrayList
        For Each NamesOfAll In CPNames
            AllNames.Add(NamesOfAll)
        Next
        Return AllNames
    End Function
    Public Function getDescription() As String
        'gets the description of the selected project
        Dim a As String
        a = Descript(TreeView1.SelectedNode.Parent.Index, TreeView1.SelectedNode.Index)
        getDescription = a
        Return getDescription
    End Function

    Private Sub menuChoice(ByVal sender As Object, ByVal e As EventArgs)
        'when the user right clickd on a project name this contextbox appears

        Dim item = CType(sender, ToolStripMenuItem)
        Dim selection = CInt(item.Tag)

        'if you select the first option, 
        'it opens up the form for changing the project name
        If (selection = 1) Then
            Dim renForm As ChangeProject
            renForm = New ChangeProject()
            renForm.Owner = Me
            renForm.Show()
            renForm = Nothing
            'if you select the second option, 
            'it opens up the form for changing the project description
        ElseIf (selection = 2) Then
            Dim desForm As ChangeDescription
            desForm = New ChangeDescription()
            desForm.Owner = Me
            desForm.Show()
            desForm = Nothing
            'if you select the Last option, 
            'it opens up the form for view the user and groups of this project
        ElseIf (selection = 3) Then
            Dim desForm As reprotTfsProject
            desForm = New reprotTfsProject()
            desForm.Owner = Me
            desForm.Show()
            desForm = Nothing
        End If
    End Sub
    Private Sub menuChoice2(ByVal sender As Object, ByVal e As EventArgs)
        'when the user right clickd on a Collection name this contextbox appears
        Dim item = CType(sender, ToolStripMenuItem)
        Dim selection = CInt(item.Tag)

        'if you select the first option, 
        'it opens up the form for view the user and groups of all project of this Collection
        If (selection = 1) Then
            Dim renForm As reprotTfsProject
            renForm = New reprotTfsProject()
            renForm.Owner = Me
            renForm.Show()
            renForm = Nothing
            'if you select the second option, 
            'it opens up the form for view all user info of the collection
        ElseIf (selection = 2) Then
            Dim renForm As ReportingTfsCollection
            renForm = New ReportingTfsCollection()
            renForm.Owner = Me
            renForm.Show()
            renForm = Nothing
        End If
    End Sub
    Private Sub menuChoice3(ByVal sender As Object, ByVal e As EventArgs)
        'when the user right clickd on a Server name this contextbox appears
        Dim item = CType(sender, ToolStripMenuItem)
        Dim selection = CInt(item.Tag)
        'if you select the first option, 
        'it opens up the form for view the user and groups of all project of this Server
        If (selection = 1) Then
            Dim renForm As ServerRepTfsProjects
            renForm = New ServerRepTfsProjects()
            renForm.Owner = Me
            renForm.Show()
            renForm = Nothing
        End If
    End Sub

    Private Sub TreeView1_NodeMouseDoubleClick1(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeNodeMouseClickEventArgs) Handles TreeView1.NodeMouseDoubleClick
        'when the user double click on a project name
        'it opens up the form for changing the project name 
        If e.Button = Windows.Forms.MouseButtons.Left Then
            TreeView1.SelectedNode = e.Node
            If (TreeView1.SelectedNode.Tag = "Project") Then
                Dim renForm As ChangeProject
                renForm = New ChangeProject()
                renForm.Owner = Me
                renForm.Show()
                renForm = Nothing
            End If
        End If
    End Sub

    Private Sub TreeView1_AfterSelect(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles TreeView1.AfterSelect
        'when the user select a project in the treeview the project information is put in the textbox under the treeview
        Dim ProjectDescription As String
        txtDescription.Clear()
        If (TreeView1.SelectedNode.Tag = "Project") Then

            ProjectDescription = LocRM.GetString("Form1.txtDescription.text1") & vbTab & getProjectName() & vbCrLf &
                                                LocRM.GetString("Form1.txtDescription.text2") & vbTab & getCollectionName() & vbCrLf &
                                                LocRM.GetString("Form1.txtDescription.text3") & vbTab & getServerName() & vbCrLf & vbCrLf &
                                                LocRM.GetString("Form1.txtDescription.text4") & vbCrLf & getDescription()
            txtDescription.Text = ProjectDescription

        End If

    End Sub
    Private Sub countCollectionAndProjects()
        'resizes the string(,)
        Dim a As Integer
        maxProject = 0
        maxCollection = collectionNodes.Count
        For Each collectionNode In collectionNodes
            ' Get a catalog of team projects for the collection
            Dim hVar As Guid() = New Guid() {CatalogResourceTypes.TeamProject}
            projectNodes = collectionNode.QueryChildren(hVar, False, CatalogQueryOptions.None)
            a = projectNodes.Count
            If (a > maxProject) Then
                maxProject = a
            End If
        Next
        ReDim Descript(maxCollection, maxProject)
    End Sub

    Private Sub EngToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EngToolStripMenuItem.Click
        'changes culture info to english canadian 
        Thread.CurrentThread.CurrentUICulture = New CultureInfo("en-CA")
        langFra = False
        resourceLanguage()
    End Sub

    Private Sub FraToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FraToolStripMenuItem.Click
        'changes culture info to french canadian
        Thread.CurrentThread.CurrentUICulture = New CultureInfo("fr-CA")
        langFra = True
        resourceLanguage()
    End Sub

    Private Sub ReadingFile()
        'reads the external file containing the information of the tfs server and its database
        Dim fileReader As System.IO.StreamReader
        Dim StringReader As String
        fileReader = My.Computer.FileSystem.OpenTextFileReader("servers.txt")
        While Not fileReader.EndOfStream
            StringReader = fileReader.ReadLine()
            extractString(StringReader)
            chargeIt()
        End While
        fileReader.Close()
        fillcmbServer()
    End Sub
    Private Sub extractString(ByVal chaine As String)
        'it acts like a split
        'felt Like trying it this way XP
        Champs.Clear()
        Dim positionDelimiteur As Integer
        Do
            positionDelimiteur = InStr(chaine, "|")
            Champs.Add(Microsoft.VisualBasic.Left(chaine, positionDelimiteur - 1))
            chaine = Microsoft.VisualBasic.Right(chaine, Len(chaine) - positionDelimiteur)
        Loop Until InStr(chaine, "|") = 0
        Champs.Add(chaine)
    End Sub
    Private Sub chargeIt()
        ' adds all the information into a sorted list
        Dim key As String
        Dim svr As New Servers
        key = Champs(0)
        svr.TfsServer = Champs(0)
        svr.TfsData = Champs(1)
        svr.TfsVersion = Champs(2)
        If (Server.ContainsKey(key)) Then
            'MessageBox.Show("this server already exist.", _
            '    "Alert", _
            '    MessageBoxButtons.OK, _
            '    MessageBoxIcon.Exclamation, _
            '    MessageBoxDefaultButton.Button1)
        Else
            Server.Add(key, svr)
        End If

    End Sub
    Private Sub fillcmbServer()
        'fills up the combobox with the tfs servers
        cmbServer.Items.Clear()
        For Each key In Server.Keys
            cmbServer.Items.Add(Server(key).TfsServer)
        Next
    End Sub

    Private Sub cmbServer_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbServer.SelectedIndexChanged
        'gets the infromation from the sorted list
        TreeView1.Nodes.Clear()
        txtServerName.Text = Server(cmbServer.SelectedItem).TfsServer
        txtDataServer.Text = Server(cmbServer.SelectedItem).TfsData
        Version = Server(cmbServer.SelectedItem).TfsVersion
        cmbItem()
    End Sub

    Private Sub AddToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddToolStripMenuItem.Click

        Dim a As New addForm
        a.Owner = Me
        a.Show()
        a.TabControl1.SelectTab(0)
    End Sub

    Private Sub EditToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EditToolStripMenuItem.Click
        Dim a As New addForm
        a.Owner = Me
        a.Show()
        a.TabControl1.SelectTab(1)
    End Sub

    Private Sub DeleteToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DeleteToolStripMenuItem.Click
        Dim a As New addForm
        a.Owner = Me
        a.Show()
        a.TabControl1.SelectTab(2)
    End Sub

    Private Sub ChangingProjectNameToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ChangingProjectNameToolStripMenuItem.Click
        helpNamingForm.Owner = Me
        helpNamingForm.Show()
    End Sub

    Private Sub TreeView1_NodeMouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeNodeMouseClickEventArgs) Handles TreeView1.NodeMouseClick
        Try
            'when the user right clicks on a treenode
            If e.Button = Windows.Forms.MouseButtons.Right Then
                TreeView1.SelectedNode = e.Node
                Nselection = TreeView1.SelectedNode.Tag
                'if its a project it will show a contextmenu with 3 items in it
                If (TreeView1.SelectedNode.Tag = "Project") Then
                    Dim cms = New ContextMenuStrip
                    Dim item1 = cms.Items.Add(LocRM.GetString("Form1.menuchoice.item1.text"))
                    item1.Tag = 1
                    AddHandler item1.Click, AddressOf menuChoice
                    Dim item2 = cms.Items.Add(LocRM.GetString("Form1.menuchoice.item2.text"))
                    item2.Tag = 2
                    AddHandler item2.Click, AddressOf menuChoice
                    Dim item3 = cms.Items.Add(LocRM.GetString("Form1.menuchoice.item3.text"))
                    item3.Tag = 3
                    AddHandler item3.Click, AddressOf menuChoice
                    cms.Show(TreeView1, e.Location)
                    'if its a Collection it will show a contextmenu with 2 items in it
                ElseIf (TreeView1.SelectedNode.Tag = "Collection") Then
                    Dim cms = New ContextMenuStrip
                    Dim item1 = cms.Items.Add(LocRM.GetString("Form1.menuchoice2.item1.text"))
                    item1.Tag = 1
                    AddHandler item1.Click, AddressOf menuChoice2
                    Dim item2 = cms.Items.Add(LocRM.GetString("Form1.menuchoice2.item2.text"))
                    item2.Tag = 2
                    AddHandler item2.Click, AddressOf menuChoice2
                    cms.Show(TreeView1, e.Location)
                    'if its a Server it will show a contextmenu with 1 items in it
                ElseIf (TreeView1.SelectedNode.Tag = "Server") Then
                    Dim cms = New ContextMenuStrip
                    Dim item1 = cms.Items.Add(LocRM.GetString("Form1.menuchoice3.item1.text"))
                    item1.Tag = 1
                    AddHandler item1.Click, AddressOf menuChoice3
                    cms.Show(TreeView1, e.Location)
                End If
            End If

        Catch ex As Exception

        End Try
    End Sub

    Private Sub resourceLanguage()
        'gets the information from a resource file
        OptionToolStripMenuItem.Text = LocRM.GetString("Form1.Menu.Option.text")
        langToolStripMenuItem.Text = LocRM.GetString("Form1.Menu.Option.languages.text")
        FraToolStripMenuItem.Text = LocRM.GetString("Form1.Menu.Option.language.fr.text")
        EngToolStripMenuItem.Text = LocRM.GetString("Form1.Menu.Option.language.en.text")
        CloseToolStripMenuItem1.Text = LocRM.GetString("Form1.Menu.Option.Close.text")
        ServersToolStripMenuItem.Text = LocRM.GetString("Form1.Menu.Servers.text")
        AddToolStripMenuItem.Text = LocRM.GetString("Form1.Menu.Servers.Add.text")
        EditToolStripMenuItem.Text = LocRM.GetString("Form1.Menu.Servers.Edit.text")
        DeleteToolStripMenuItem.Text = LocRM.GetString("Form1.Menu.Servers.Delete.text")
        HelpToolStripMenuItem.Text = LocRM.GetString("Form1.Menu.Help.text")
        btnCheckServer.Text = LocRM.GetString("Form1.btnCheckServer.test")
        ChangingProjectNameToolStripMenuItem.Text = LocRM.GetString("form1.ChangeProjectName.text")
    End Sub

    Public Sub cmbItem()
        If (cmbServer.Items.Count = 0) Then
            btnCheckServer.Enabled = False
        Else
            btnCheckServer.Enabled = True
        End If
        If (cmbServer.SelectedIndex = -1) Then
            btnCheckServer.Enabled = False
        Else
            btnCheckServer.Enabled = True
        End If
    End Sub
End Class
