﻿Imports System
Imports System.Collections.ObjectModel
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.OleDb.OleDbConnection
Imports Microsoft.TeamFoundation.Client
Imports Microsoft.TeamFoundation.Framework.Common
Imports Microsoft.TeamFoundation.Framework.Client
Imports System.Resources
Imports System.Threading
Imports System.Globalization

Public Class ChangeProject

    Private projectName As String
    Private ProjectCollection As String
    Private serverName As String
    Private ServerData As String
    Private AllName As New ArrayList
    Private projectPathName As String
    Private NewprojectPathName As String
    Private version As String

    Dim LocRM As New ResourceManager("RenamingTool.Resource", GetType(MainPage).Assembly)

    Private Sub BtnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnCancel.Click
        MainPage.Enabled = True
        MainPage.Focus()
        Me.Close()
    End Sub

    Private Sub RenameProject_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'loads up the page
        'and gets all the needed information
        MainPage.Enabled = False
        txtDescription.Text = MainPage.getDescription()
        projectName = MainPage.getProjectName
        ProjectCollection = MainPage.getCollectionName
        serverName = MainPage.getServerName
        ServerData = MainPage.getDataTierName
        version = MainPage.getVersion()
        AllName = MainPage.getAllNames

        Me.Text = projectName
        If (MainPage.langFra) Then
            Thread.CurrentThread.CurrentUICulture = New CultureInfo("fr-CA")
        Else
            Thread.CurrentThread.CurrentUICulture = New CultureInfo("en-CA")
        End If
        changeLang()
    End Sub
    Private Function authorization() As Boolean
        Dim sameName As Boolean = False

        'make sure that all information and restriction follows:
        '-both server must be verefied
        '-the new project must not be empty
        '-no project name or collection must be the same as the new project name
        '-make sure no speacial characters 



        If (txtProjectNewName.Text.Length() <> 0) Then
            Dim numList As Integer = 0

            For Each projName In AllName
                If (txtProjectNewName.Text.ToUpper = projName.ToString.ToUpper) Then
                    If (projectName.ToUpper <> txtProjectNewName.Text.ToUpper) Then
                        sameName = True
                    End If
                End If
            Next
            If (serverName.ToUpper = txtProjectNewName.Text.ToUpper) Then
                sameName = True
            End If
            Dim dataserver As String() = ServerData.Split(New Char() {"\"c})
            If (txtProjectNewName.Text.ToUpper = dataserver(0).ToUpper Or txtProjectNewName.Text.ToUpper = dataserver(1).ToUpper Or txtProjectNewName.Text.ToUpper = ServerData.ToUpper) Then
                sameName = True
            End If
            For i = 0 To txtProjectNewName.Text.Length - 1

                Select Case txtProjectNewName.Text.Substring(i, 1)
                    Case "/"
                        sameName = True
                    Case ":"
                        sameName = True
                    Case "\"
                        sameName = True
                    Case "~"
                        sameName = True
                    Case "&"
                        sameName = True
                    Case "%"
                        sameName = True
                    Case ";"
                        sameName = True
                    Case "@"
                        sameName = True
                    Case "'"
                        sameName = True
                    Case """"
                        sameName = True
                    Case "?"
                        sameName = True
                    Case "<"
                        sameName = True
                    Case ">"
                        sameName = True
                    Case "|"
                        sameName = True
                    Case "#"
                        sameName = True
                    Case "$"
                        sameName = True
                    Case "*"
                        sameName = True
                    Case "}"
                        sameName = True
                    Case "{"
                        sameName = True
                    Case ","
                        sameName = True
                    Case "+"
                        sameName = True
                    Case "="
                        sameName = True
                    Case "["
                        sameName = True
                    Case "]"
                        sameName = True
                End Select

                If (txtProjectNewName.Text.Substring(0, 1) = "_") Then
                    sameName = True
                End If
                If (txtProjectNewName.Text.Substring(0, 1) = "." Or _
                    txtProjectNewName.Text.Substring(txtProjectNewName.Text.Length - 1, 1) = ".") Then
                    sameName = True
                End If
                Select Case txtProjectNewName.Text.ToUpper
                    Case "CON"
                        sameName = True
                    Case "AUX"
                        sameName = True
                    Case "PRN"
                        sameName = True
                    Case "COM1"
                        sameName = True
                    Case "LPT2"
                        sameName = True
                End Select
            Next
            If (sameName = False) Then
                Return True
            Else
                MessageBox.Show(LocRM.GetString("Error_RenamingProject"), _
                "Alert Notice", _
                MessageBoxButtons.OK, _
                MessageBoxIcon.Error, _
                MessageBoxDefaultButton.Button1)
            End If
        Else
            MessageBox.Show(LocRM.GetString("Error_NoNewName"), _
            "Alert Notice", _
            MessageBoxButtons.OK, _
            MessageBoxIcon.Error, _
            MessageBoxDefaultButton.Button1)
        End If

        Return False

    End Function

    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        'when the user click on save...
        Me.Cursor = Cursors.WaitCursor
        If (authorization()) Then
            projectPathName = wordReplace(projectName)
            NewprojectPathName = wordReplace(txtProjectNewName.Text)
            If (version = "2010") Then
                sqlcode2010()
            ElseIf (version = "2012") Then
                sqlcode2012()
            End If

            MainPage.FillTreeView(serverName)
            MainPage.Enabled = True
            MainPage.Focus()
            Me.Cursor = Cursors.Arrow
            Me.Close()
        Else
            Me.Cursor = Cursors.Arrow
        End If

    End Sub
    Private Sub chkDescription_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDescription.CheckedChanged

        'if the checkbox is checked it will allow the changes to the description textbox

        If (chkDescription.Checked) Then
            txtDescription.ReadOnly = False
        Else
            txtDescription.ReadOnly = True
        End If
    End Sub
    Private Sub sqlcode2010()

        Dim connectionsql As String
        Dim querysql As String

        'the sql queries 

        '--------------------------------------------------------------
        'database: tfs_configuration

        connectionsql = "Data Source=" & ServerData & ";Initial Catalog=Tfs_Configuration;Integrated Security=True"
        querysql = "Update [dbo].[tbl_CatalogResource]  " &
                        "set[DisplayName]='" & txtProjectNewName.Text & "' " &
                        "Where [DisplayName]='" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_PropertyValue] " &
                        "set[StringValue]=replace([StringValue],'" & projectName & "','" & txtProjectNewName.Text & "')" &
                        "Where [StringValue] = '" & projectName & "'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_security_identity_cache] " &
                        "set[display_name]=replace([display_name],'[" & projectPathName & "]','[" & NewprojectPathName & "]')" &
                        "Where [display_name] like '%[" & projectPathName & "]%'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_security_projects] " &
                        "set[scope_name]='" & NewprojectPathName & "'" &
                        "Where [scope_name]='" & projectPathName & "'"
        updateRow(connectionsql, querysql)

        '-----------------------------------------------------------
        'database: tfs_ReportServer$TFSD

        Dim connectionsql2 As String = "Data Source=" & ServerData & ";Initial Catalog=ReportServer$TFSD;Integrated Security=True"
        querysql = "Update [dbo].[Catalog] " &
                    " set [Name] = '" & txtProjectNewName.Text & "'" &
                    " Where [Name] = '" & projectName & "'"
        updateRow(connectionsql2, querysql)

        querysql = "Update [dbo].[Catalog] " &
                    " set [Path] = replace([Path],'" & projectName & "','" & txtProjectNewName.Text & "')" &
                    " Where [Path] like '%/" & projectName & "'"
        updateRow(connectionsql2, querysql)

        querysql = "Update [dbo].[Catalog] " &
                    " set [Path] = replace([Path],'" & projectName & "','" & txtProjectNewName.Text & "')" &
                    " Where [Path] like '%/" & projectName & "/%'"
        updateRow(connectionsql2, querysql)

        '-----------------------------------------------------------
        'database: tfs_Warehouse

        connectionsql = "Data Source=" & ServerData & ";Initial Catalog=Tfs_Warehouse;Integrated Security=True"
        querysql = "Update [dbo].[DimTeamProject]" &
                        "set [ProjectNodeName]='" & txtProjectNewName.Text & "'" &
                        "where [ProjectNodeName]='" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[DimFile]" &
                        "set [FileName]='" & txtProjectNewName.Text & "\'" &
                        "where [FileName]='" & projectName & "\'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[DimFile] " &
                        "set [FileName]= '" & txtProjectNewName.Text & "'" &
                        "where [FileName]= '" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[DimPerson] " &
                        "set[Name]=REPLACE([Name],'" & projectName & "','" & txtProjectNewName.Text & "')" &
                        "where [Name] like '%[" & projectName & "]%'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[DimTeamProject] " &
                        "set [ProjectNodeName] = '" & txtProjectNewName.Text & "'" &
                        "Where [ProjectNodeName] = '" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update[dbo].[DimIteration]" &
                    "set [IterationName] = '" & txtProjectNewName.Text & "'" &
                    "where [IterationName] = '" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update[dbo].[DimArea]" &
                    "set [AreaName] = '" & txtProjectNewName.Text & "'" &
                    "where [AreaName] = '" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update[dbo].[_DimIterationOverlay]" &
                    "set [IterationPath] = replace([IterationPath],'" & projectName & "','" & txtProjectNewName.Text & "')" &
                    "where [IterationPath] = '\" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update[dbo].[_DimIterationOverlay]" &
                    "set [IterationPath] = replace([IterationPath],'" & projectName & "','" & txtProjectNewName.Text & "')" &
                    "where [IterationPath] like '\" & projectName & "\%'"
        updateRow(connectionsql, querysql)

        '-----------------------------------------------------------
        'database: tfs_"ProjectCollection"

        connectionsql = "Data Source=" & ServerData & ";Initial Catalog=Tfs_" & ProjectCollection & ";Integrated Security=True"

        querysql = "Update [dbo].[ADObjects] " &
                        "set [DisplayName] = replace([DisplayName],'[" & projectName & "]','[" & txtProjectNewName.Text & "]')" &
                        "where [DisplayName] like '%[" & projectName & "]%'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_Area] " &
                    "set [AreaPath] = '" & txtProjectNewName.Text & "'" &
                    "where [AreaPath] = '" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[Constants] " &
                        "set [DisplayPart] = replace([DisplayPart],'[" & projectName & "]','[" & txtProjectNewName.Text & "]')" &
                        "where [DisplayPart] like '%[" & projectName & "]%'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_LocalVersion] " &
                        "set [LocalChildItem] = '" & NewprojectPathName & "\'" &
                        "Where [LocalChildItem] = '" & projectPathName & "\'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_Version] " &
                        "set [ParentPath] = replace([ParentPath],'$\" & projectPathName & "\','$\" & NewprojectPathName & "\')" &
                        "where [ParentPath] like '%$\" & projectPathName & "\%'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_VersionedItem] " &
                        "set [ChildItem] = '" & NewprojectPathName & "\'" &
                        "Where [ChildItem] = '" & projectPathName & "\' and [ParentPath] = '$\'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_VersionedItem] " &
                        "set [ParentPath] = replace([ParentPath],'$\" & projectPathName & "\','$\" & NewprojectPathName & "\')" &
                        "where [ParentPath] like '%$\" & projectPathName & "\%'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[TreeNodes] " &
                        "set [Name] = '" & txtProjectNewName.Text & "'" &
                        "where [Name] = '" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[TreeNodes] " &
                        "set [NewName] = '" & txtProjectNewName.Text & "'" &
                        "where [NewName] = '" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[xxTree] " &
                        "set [Node Name] = '" & txtProjectNewName.Text & "'" &
                        "where [Node Name] = '" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[xxTree] " &
                        "set [Team Project] = Replace([Team Project],'" & projectName & "','" & txtProjectNewName.Text & "')" &
                        "where [Team Project] = '" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_Project] " &
                        "set [ProjectName] = '" & txtProjectNewName.Text & "'" &
                        "where [ProjectName] = '" & projectName & "'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_projects] " &
                        "set [project_name] = '" & NewprojectPathName & "'" &
                        "where [project_name] = '" & projectPathName & "'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_Version] " &
                        "set [ChildItem] = '" & NewprojectPathName & "\'" &
                        "where [ChildItem] = '" & projectPathName & "\'  and [ParentPath] = '$\'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_WorkingFolder] " &
                        "set [ServerItem] = '$\" & NewprojectPathName & "\'" &
                        "where [ServerItem] = '$\" & projectPathName & "\'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_ReleaseNoteDefinition] " &
                        "set [AssociatedItem] = '$\" & NewprojectPathName & "\'" &
                        "where [AssociatedItem] = '$\" & projectPathName & "\'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_WorkspaceMapping] " &
                        "set [SourceServerItem] = '$\" & txtProjectNewName.Text & "\'" &
                        "where [SourceServerItem] = '$\" & projectName & "\'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_WorkspaceMapping] " &
                        "set [ChildStart] = '" & NewprojectPathName & "\'" &
                        "where [ChildStart] = '" & projectPathName & "\'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_WorkspaceMapping] " &
                        "set [ChildEnd] = '" & NewprojectPathName & "\'" &
                        "where [ChildEnd] = '" & projectPathName & "\'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_BuildProcessTemplate] " &
                        "set [ServerPath] = replace([ServerPath],'" & projectName & "','" & txtProjectNewName.Text & "')" &
                        "where [ServerPath] like '%/" & projectName & "/%'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_SecurityAccessControlEntry] " &
                        "set [IndexableToken] = '$/" & txtProjectNewName.Text & "/'" &
                        "where [IndexableToken]= '$/" & projectName & "/'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_SecurityAccessControlEntry] " &
                        "set [SecurityToken] = '$/" & txtProjectNewName.Text & "/'" &
                        "where [SecurityToken] = '$/" & projectName & "/'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_SecurityTokenDelta] " &
                        "set [IndexableToken] = '$/" & txtProjectNewName.Text & "/'" &
                        "where [IndexableToken]= '$/" & projectName & "/'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_SecurityTokenDelta] " &
                        "set [SecurityToken] = '$/" & txtProjectNewName.Text & "/'" &
                        "where [SecurityToken] = '$/" & projectName & "/'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_Iteration]" &
                    "set [Iteration] = replace([Iteration],'" & projectName & "','" & txtProjectNewName.Text & "')" &
                    "where [Iteration] = '" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_Iteration]" &
                    "set [Iteration] = replace([Iteration],'" & projectName & "\','" & txtProjectNewName.Text & "\')" &
                    "where [Iteration] like '" & projectName & "\%'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_nodes]" &
                    "set [path] = replace([path],'\" & projectPathName & "\','\" & NewprojectPathName & "\')" &
                    "where [path] like '\" & projectPathName & "\%'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[xxTree]" &
                    "set [Area Path] = replace([Area Path],'\\" & projectName & "','\\" & txtProjectNewName.Text & "')" &
                    "where [Area Path] like '\\" & projectName & "%'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_Branch]" &
                    "set [ParentPath] = replace([ParentPath],'$\" & projectPathName & "\','$\" & NewprojectPathName & "\')" &
                    "where [ParentPath] like '$\" & projectPathName & "\%'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_WorkingFolder]" &
                    "set [ServerItem] = '$\" & NewprojectPathName & "\'" &
                    "where [ServerItem] = '$\" & projectPathName & "\'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_WorkspaceMapping]" &
                    "set [LocalItem] = replace([LocalItem],'\" & projectPathName & "\','\" & NewprojectPathName & "\')" &
                    "where [LocalItem] like '%\" & projectPathName & "\%'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_WorkspaceMapping]" &
                    "set [ChildEnd] = '" & NewprojectPathName & "\'" &
                    "where [ChildEnd] = '" & projectPathName & "\'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_WorkspaceMapping]" &
                    "set [ChildStart] = '" & NewprojectPathName & "\'" &
                    "where [ChildStart] = '" & projectPathName & "\'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_LocalVersion]" &
                    "set [LocalParentPath] = replace([LocalParentPath],'\" & projectPathName & "\','\" & NewprojectPathName & "\')" &
                    "where [LocalParentPath] like '%\" & projectPathName & "\%'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_WorkingFolder]" &
                    "set [LocalItem] = replace([LocalItem],'\" & projectPathName & "\','\" & NewprojectPathName & "\')" &
                    "where [LocalItem] like '%\" & projectPathName & "\%'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_PendingChange]" &
                    "set [CommittedServerItem] = replace([CommittedServerItem],'$\" & projectName & "\','$\" & txtProjectNewName.Text & "\')" &
                    "where [CommittedServerItem] like '%$\" & projectName & "\%'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_PendingChange]" &
                    "set [TargetParentPath] = replace([TargetParentPath],'$\" & projectPathName & "\','$\" & NewprojectPathName & "\')" &
                    "where [TargetParentPath] like '%$\" & projectPathName & "\%'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_PendingMerge]" &
                    "set [TargetServerItem] = replace([TargetServerItem],'$\" & projectName & "\','$\" & txtProjectNewName.Text & "\')" &
                    "where [TargetServerItem] like '%$\" & projectName & "\%'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_WorkspaceMapping]" &
                    "set [SourceServerItem] = replace([SourceServerItem],'$\" & projectPathName & "\','$\" & NewprojectPathName & "\')" &
                    "where [SourceServerItem] like '%$\" & projectPathName & "\%'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_WorkspaceMapping]" &
                    "set [ParentEnd] = replace([ParentEnd],'$\" & projectPathName & "\','$\" & NewprojectPathName & "\')" &
                    "where [ParentEnd] like '%$\" & projectPathName & "\%'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_WorkspaceMapping]" &
                    "set [ParentEnd] = replace([ParentEnd],'$\" & projectPathName & "]','$\" & NewprojectPathName & "]')" &
                    "where [ParentEnd] like '%$\" & projectPathName & "]%'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_Parameter]" &
                    "set [ParameterValue] = replace([ParameterValue],'$/" & projectName & "/','$/" & txtProjectNewName.Text & "/')" &
                    "where [ParameterValue] like '%$/" & projectName & "/%'"
        updateRow(connectionsql, querysql)

        '*
        querysql = "Update [dbo].[tbl_WorkingFolder]" &
                    "set [ServerItem] = replace([ServerItem],'\" & projectPathName & "\','\" & NewprojectPathName & "\')" &
                    "where [ServerItem] like '%$\" & projectPathName & "\%'"
        updateRow(connectionsql, querysql)

        querysql = "Update[dbo].[tbl_WorkspaceMapping]" &
                    "set [ParentStart] = REPLACE([ParentStart],'\" & projectPathName & "\','\" & NewprojectPathName & "\')" &
                    "where [ParentStart] like '%\" & projectPathName & "\%'"
        updateRow(connectionsql, querysql)

        querysql = "Update[dbo].[QueryItems]" &
                    "set [Text] = REPLACE([Text],'''" & projectName & "\','''" & txtProjectNewName.Text & "\')" &
                    "where [Text] like '%''" & projectName & "\%'"
        updateRow(connectionsql, querysql)

        querysql = "Update[dbo].[QueryItems]" &
                    "set [Text] = REPLACE([Text],'''" & projectName & "''','''" & txtProjectNewName.Text & "''')" &
                    "where [Text] like '%''" & projectName & "''%'"
        updateRow(connectionsql, querysql)

        querysql = "Update[dbo].[TempADObjects]" &
                    "set [N] = REPLACE([N],'[" & projectName & "]','[" & txtProjectNewName.Text & "]')" &
                    "where [N] like '%[" & projectName & "]%'"
        updateRow(connectionsql, querysql)

        querysql = "Update[dbo].[tbl_Lock]" &
                    "set [FullPath] = REPLACE([FullPath],'\" & projectPathName & "\','\" & NewprojectPathName & "\')" &
                    "where [FullPath] like '%\" & projectPathName & "\%'"
        updateRow(connectionsql, querysql)

        querysql = "Update[dbo].[tbl_Lock]" &
                    "set [FullPath] = REPLACE([FullPath],'\" & projectPathName & "\','\" & NewprojectPathName & "\')" &
                    "where [FullPath] like '%\" & projectPathName & "\%'"
        updateRow(connectionsql, querysql)

        querysql = "Update[dbo].[tbl_Parameter]" &
                    "set [ParameterValue] = REPLACE([ParameterValue],'[" & projectPathName & "]','[" & NewprojectPathName & "]')" &
                    "where [ParameterValue] like '%[" & projectPathName & "]%'"
        updateRow(connectionsql, querysql)

        querysql = "Update[dbo].[tbl_Parameter]" &
                    "set [ParameterValue] ='$/" & txtProjectNewName.Text & "'" &
                    "where [ParameterValue] ='$/" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update[dbo].[Constants]" &
                    "set DisplayPart = '*Builds - " & txtProjectNewName.Text & "'" &
                    "where DisplayPart = '*Builds -" & projectName & "'"
        updateRow(connectionsql, querysql)
        '--------------------------------------------
        querysql = "Update[dbo].[BuildUri]" &
                    "set [Project] = '" & txtProjectNewName.Text & "'" &
                    "where [Project] = '" & projectName & "'"
        updateRow(connectionsql, querysql)
        '--------------------------------------------
        querysql = "Update[dbo].[tbl_BuildDefinitionMapping]" &
                    "set [ServerItem] = replace([ServerItem],'$\" & projectPathName & "\','$\" & NewprojectPathName & "\')" &
                    "where [ServerItem] like '%" & projectPathName & "%'"
        updateRow(connectionsql, querysql)
        '--------------------------------------------
        querysql = "Update[dbo].[tbl_BuildCodeChange]" &
                    "set [FileName] = replace([FileName],'$/" & projectPathName & "/','$/" & NewprojectPathName & "/')" &
                    "where [FileName] like '%" & projectPathName & "%'"
        updateRow(connectionsql, querysql)
        '--------------------------------------------
        querysql = "Update[dbo].[tbl_BuildInformationField]" &
                    "set [FieldValue] = replace([FieldValue],'$/" & projectPathName & "/','$/" & NewprojectPathName & "/')" &
                    "where [FieldValue] like '%" & projectPathName & "%'"
        updateRow(connectionsql, querysql)
        '--------------------------------------------
        querysql = "Update[dbo].[tbl_PendingChangeRecursive]" &
                    "set [SourceParentPath] = replace([SourceParentPath],'$\" & projectPathName & "\','$\" & NewprojectPathName & "\')" &
                    "where [SourceParentPath] like '%" & projectPathName & "%'"
        updateRow(connectionsql, querysql)

        querysql = "Update[dbo].[tbl_BuildDefinition]" &
                    "set [ProcessParameters] = REPLACE([ProcessParameters],'$/" & projectName & "/','$/" & txtProjectNewName.Text & "/')" &
                    "where [ProcessParameters] like '%$/" & projectName & "/%'"

        Description()

    End Sub
    Public Sub sqlcode2012()

        Dim connectionsql As String
        Dim querysql As String

        connectionsql = "Data Source=" & ServerData & ";Initial Catalog=ReportServer$TFSD;Integrated Security=True"
        querysql = "Update [dbo].[Catalog]" &
                    "set [Name] = '" & txtProjectNewName.Text & "'" &
                    "where [Name] = '" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[Catalog]" &
                    "set [Path] = replace([Path],'" & projectName & "','" & txtProjectNewName.Text & "')" &
                    "where [Path] like '%/" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[Catalog]" &
                    "set [Path] = replace([Path],'" & projectName & "','" & txtProjectNewName.Text & "')" &
                    "where [Path] like '%/" & projectName & "/%'"
        updateRow(connectionsql, querysql)

        '-----------------------------------------------------------------------------

        connectionsql = "Data Source=" & ServerData & ";Initial Catalog=Tfs_Configuration;Integrated Security=True"
        querysql = "Update [dbo].[tbl_CatalogResource]" &
                    "set [DisplayName] = '" & txtProjectNewName.Text & "'" &
                    "where [DisplayName] = '" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_PropertyValue]" &
                    "set [LeadingStringValue] = '" & txtProjectNewName.Text & "'" &
                    "where [LeadingStringValue] = '" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_security_projects]" &
                    "set [scope_name] = '" & txtProjectNewName.Text & "'" &
                    "where [scope_name] = '" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_gss_groups]" &
                    "set [display_name] = replace([display_name],'" & projectName & "','" & txtProjectNewName.Text & "')" &
                    "where [display_name] = '" & projectName & " Team'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_security_identity_cache]" &
                    "set [account_name] = replace([account_name],'" & projectName & "','" & txtProjectNewName.Text & "')" &
                    "where [account_name] = '" & projectName & " Team'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_security_identity_cache]" &
                    "set [display_name] = replace([display_name],'" & projectName & "','" & txtProjectNewName.Text & "')" &
                    "where [display_name] like '%[" & projectName & "]%'"
        updateRow(connectionsql, querysql)

        '---------------------------------------------------------------------------------

        connectionsql = "Data Source=" & ServerData & ";Initial Catalog=Tfs_" & ProjectCollection & ";Integrated Security=True"

        querysql = "Update [dbo].[ADObjects]" &
                    "set [DisplayName] = replace([DisplayName],'" & projectName & "','" & txtProjectNewName.Text & "')" &
                    "where [DisplayName] like '[" & projectName & "]%'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[ADObjects]" &
                    "set [SamAccountName] = replace([SamAccountName],'" & projectName & "','" & txtProjectNewName.Text & "')" &
                    "where [SamAccountName] like '" & projectName & "%'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[Constants]" &
                 "set [DisplayPart] = replace([DisplayPart],'" & projectName & "','" & txtProjectNewName.Text & "')" &
                    "where [DisplayPart] like '[" & projectName & "]%'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[Constants]" &
                    "set [NamePart] = replace([NamePart],'" & projectName & "','" & txtProjectNewName.Text & "')" &
                    "where [NamePart] like '" & projectName & "%'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[LabProject]" &
                 "set [ProjectName] = '" & txtProjectNewName.Text & "'" &
                    "where [ProjectName] = '" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_Area]" &
                    "set [AreaPath]= '" & txtProjectNewName.Text & "'" &
                "where [AreaPath]= '" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_BuildProcessTemplate]" &
                "set [ServerPath] = replace([ServerPath],'" & projectName & "','" & txtProjectNewName.Text & "')" &
                "where [ServerPath] like '$\" & projectName & "\%'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_Iteration]" &
             "set [Iteration]= '" & txtProjectNewName.Text & "'" &
                "where [Iteration]= '" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_Iteration]" &
                "set [Iteration] = replace([Iteration],'" & projectName & "','" & txtProjectNewName.Text & "')" &
                "where [Iteration] like '" & projectName & "\%'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_nodes]" &
                "set [path] = replace([path],'" & projectName & "','" & txtProjectNewName.Text & "')" &
                "where [path] like '\" & projectName & "\%'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_Project]" &
                "set [ProjectName]= '" & txtProjectNewName.Text & "'" &
                "where [ProjectName]= '" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_projects]" &
                "set [project_name]= '" & txtProjectNewName.Text & "'" &
                "where [project_name]= '" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_SecurityAccessControlEntry]" &
                    "set [IndexableToken]= '$/" & txtProjectNewName.Text & "/'" &
                    "where [IndexableToken]= '$/" & projectName & "/'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_SecurityAccessControlEntry]" &
                "set [SecurityToken]= '$/" & txtProjectNewName.Text & "/'" &
                "where [SecurityToken]= '$/" & projectName & "/'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_SecurityTokenDelta]" &
                "set [IndexableToken]= '$/" & txtProjectNewName.Text & "/'" &
                    "where [IndexableToken]= '$/" & projectName & "/'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_SecurityTokenDelta]" &
                    "set [SecurityToken]= '$/" & txtProjectNewName.Text & "/'" &
                    "where [SecurityToken]= '$/" & projectName & "/'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_TeamConfigurationTeamFields]" &
                    "set [TeamFieldValue]= '" & txtProjectNewName.Text & "'" &
                    "where [TeamFieldValue]= '" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_Version]" &
                    "set [ChildItem]= '" & txtProjectNewName.Text & "\'" &
                    "where [ChildItem]= '" & projectName & "\'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[tbl_Version]" &
                 "set [ParentPath] = replace([ParentPath],'" & projectName & "','" & txtProjectNewName.Text & "')" &
                    "where [ParentPath] like '$\" & projectName & "\%'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[TreeNodes]" &
                    "set [Name]= '" & txtProjectNewName.Text & "'" &
                    "where [Name]= '" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[xxTree]" &
                    "set [Area Path]= '\\" & txtProjectNewName.Text & "'" &
                     "where [Area Path]= '\\" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[xxTree]" &
                    "set [Area Path] = replace([Area Path],'" & projectName & "','" & txtProjectNewName.Text & "')" &
                    "where [Area Path] like '\\" & projectName & "\%'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[xxTree]" &
                    "set [Node Name] = '" & txtProjectNewName.Text & "'" &
                    "where [Node Name]= '" & projectName & "'"
        updateRow(connectionsql, querysql)

        querysql = "Update [dbo].[xxTree]" &
                    "set [Team Project]  = '" & txtProjectNewName.Text & "'" &
                    "where [Team Project]= '" & projectName & "'"
        updateRow(connectionsql, querysql)
        '-----------------------------------------------------------------------------
        Description()
    End Sub
    Public Sub updateRow(ByVal myConnectionString As String, ByVal myQueryString As String)

        Dim myConnection As New SqlConnection(myConnectionString)
        Dim myCommand As New SqlCommand(myQueryString)
        myCommand.Connection = myConnection
        myConnection.Open()
        myCommand.ExecuteNonQuery()
        myCommand.Connection.Close()



    End Sub
    Private Sub Description()

        'this will change the description on the database

        If (chkDescription.Checked) Then
            Dim connectionsql As String
            Dim querysql As String
            connectionsql = "Data Source=" & ServerData & ";Initial Catalog=Tfs_Configuration;Integrated Security=True"
            querysql = "update [dbo].[tbl_CatalogResource]" &
                        "set [Description] = '" & txtDescription.Text & "'" &
                        "Where [DisplayName] = '" & txtProjectNewName.Text & "'"
            updateRow(connectionsql, querysql)
        End If
    End Sub
    Private Function wordReplace(ByVal ori As String) As String
        'because of the changes of the database
        'some characters li - and _ are replaced by " or >
        'this converts theise characters
        Dim a As String = ""

        For i = 0 To ori.Length - 1
            If (ori.Substring(i, 1) = "-") Then
                a += """"
            ElseIf (ori.Substring(i, 1) = "_") Then
                a += ">"
            Else
                a += ori.Substring(i, 1)
            End If
        Next
        Return a
    End Function
    Private Sub changeLang()
        'gets info from resource files
        Label1.Text = LocRM.GetString("RenameProject.label1.text")
        Label2.Text = LocRM.GetString("RenameProject.label2.text")
        chkDescription.Text = LocRM.GetString("RenameProject.chkDescription.text")
        btnSave.Text = LocRM.GetString("RenameProject.btnSave.text")
        BtnCancel.Text = LocRM.GetString("RenameProject.btnCancel.text")
    End Sub
End Class