﻿Imports System.Data
Imports System.Data.SqlClient
Imports Microsoft.TeamFoundation.Client
Imports Microsoft.TeamFoundation.Framework.Common
Imports Microsoft.TeamFoundation.Framework.Client
Imports Microsoft.TeamFoundation.Common
Imports Microsoft.TeamFoundation.VersionControl.Client
Imports System.Globalization
Imports System.Threading
Imports System.Resources


Public Class ReportingTfsCollection

    Private ProjectCollection As String
    Private serverName As String
    Private ServerData As String

    Dim tfs As TfsTeamProjectCollection
    Dim sec As IIdentityManagementService
    Dim vcs As VersionControlServer
    Dim appGroups() As TeamFoundationIdentity

    Dim LocRM As New ResourceManager("RenamingTool.Resource", GetType(MainPage).Assembly)

    Private Sub ReportingTfsCollection_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ProjectCollection = MainPage.getCollectionNameFromCollection
        serverName = MainPage.getServerNameFromCollection
        ServerData = MainPage.getDataTierName

        If MainPage.langFra Then
            Thread.CurrentThread.CurrentUICulture = New CultureInfo("fr-CA")
        Else
            Thread.CurrentThread.CurrentUICulture = New CultureInfo("en-CA")
        End If
        Button1.Text = LocRM.GetString("CollectionInfo.Close")
        initializing()
    End Sub
    Private Sub initializing()
        'http://www.codeproject.com/Articles/262673/TFS-SDK-Get-Groups-Users-Permissions-using-TFS-API
        Try
            tfs = _
                    TfsTeamProjectCollectionFactory.GetTeamProjectCollection( _
                      New Uri("http://" & serverName & ":8080/tfs/" & ProjectCollection))
            tfs.EnsureAuthenticated()
            '    // Group Security service exposes methods to get groups, users and security details
            sec = tfs.GetService(Of IIdentityManagementService)()

            '    // Version control service exposes methods to work with TFS version control
            vcs = tfs.GetService(Of VersionControlServer)()

            '    // Since we'll be reporting groups for all team projects, imp to get all team projects


            appGroups = _
                       sec.ListApplicationGroups(Nothing, ReadIdentityOptions.None)

            ListV2()
        Catch ex As Exception
            MessageBox.Show(LocRM.GetString("Error_CollectionUnavailable") & ": " & ProjectCollection, _
                                "Alert Notice", _
                                MessageBoxButtons.OK, _
                                MessageBoxIcon.Exclamation, _
                                MessageBoxDefaultButton.Button1)
        End Try




    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        MainPage.Focus()
        Me.Close()
    End Sub

    Private Sub ListV2()
        Dim int1 As Integer = 0
        Dim int2 As Integer = 0
        Dim int3 As Integer = 0

        For Each group In appGroups
            TreeView1.Nodes.Add(group.DisplayName.ToString)
            TreeView1.Nodes(int1).Text = group.DisplayName.ToString

            Dim SearchFactors As String = group.DisplayName.ToString
            Dim groupMembers As TeamFoundationIdentity = sec.ReadIdentity(searchFactor:=IdentitySearchFactor.AccountName, _
            searchFactorValue:=SearchFactors, queryMembership:=MembershipQuery.Direct, readOptions:=ReadIdentityOptions.TrueSid)

            Dim nodeMembers() As TeamFoundationIdentity = sec.ReadIdentities(groupMembers.Members, MembershipQuery.Direct, _
                                                 ReadIdentityOptions.TrueSid)

            int2 = 0
            For Each m In nodeMembers

                TreeView1.Nodes(int1).Nodes.Add(m.DisplayName.ToString)
                TreeView1.Nodes(int1).Nodes(int2).Text = m.DisplayName.ToString

                Dim mMember() As TeamFoundationIdentity = sec.ReadIdentities(m.Members, MembershipQuery.Expanded, _
                                             ReadIdentityOptions.TrueSid)
                int3 = 0
                For Each gMember In mMember
                    TreeView1.Nodes(int1).Nodes(int2).Nodes.Add(gMember.DisplayName.ToString)
                    TreeView1.Nodes(int1).Nodes(int2).Nodes(int3).Text = gMember.DisplayName.ToString
                    Dim mmMember() As TeamFoundationIdentity = sec.ReadIdentities(m.Members, MembershipQuery.Expanded, _
                                             ReadIdentityOptions.TrueSid)

                    int3 += 1
                Next
                int2 += 1
            Next
            int1 += 1
        Next

    End Sub
End Class