﻿Imports System.Data
Imports System.Data.SqlClient
Imports Microsoft.TeamFoundation.Client
Imports Microsoft.TeamFoundation.Framework.Common
Imports Microsoft.TeamFoundation.Framework.Client
Imports Microsoft.TeamFoundation.Common
Imports Microsoft.TeamFoundation.VersionControl.Client
Imports System.Globalization
Imports System.Threading
Imports System.Collections.ObjectModel
Imports CrystalDecisions.Shared
Imports CrystalDecisions.CrystalReports.Engine
Imports System.Resources

Public Class ServerRepTfsProjects

    Private projectName As String
    Private ProjectCollection As String
    Private serverName As String
    Private ServerData As String
    Private GGMember As TeamFoundationIdentity

    Dim numberkey As Integer = 0

    Dim ds As New DataSet1
    Dim t As DataTable = ds.DataTable1
    Dim Report As DataTable = ds.Report_Info

    Dim project As TeamProject

    Dim tfsUri As Uri
    Dim collectionNodes As ReadOnlyCollection(Of CatalogNode)
    Dim configurationServer As TfsConfigurationServer

    Dim teamProjectCollectionGroup As String

    Dim sec As IIdentityManagementService
    Dim vcs As VersionControlServer
    Dim appGroups() As TeamFoundationIdentity
    Dim groupMembers As TeamFoundationIdentity
    Dim nodeMembers() As TeamFoundationIdentity

    Dim UserPermissions As New Dictionary(Of Integer, Permissions)
    Dim LocRM As New ResourceManager("RenamingTool.Resource", GetType(MainPage).Assembly)

    Private Sub ServerRepTfsProjects_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'when form loads
        'it gets all information required from whatever treenode the user chooses
        'creates the listview
        MainPage.Enabled = False
        serverName = MainPage.getServerNameFromServer
        ServerData = MainPage.getDataTierName

        If MainPage.langFra Then
            Thread.CurrentThread.CurrentUICulture = New CultureInfo("fr-CA")
        Else
            Thread.CurrentThread.CurrentUICulture = New CultureInfo("en-CA")
        End If

        Label1.Text = LocRM.GetString("Report.Label1")
        Label2.Text = LocRM.GetString("Report.Label2")
        ButtonPrintListView.Text = LocRM.GetString("Report.BtnPrint")
        Button1.Text = LocRM.GetString("Report.btnClose")

        ListView1.View = View.Details
        ListView1.FullRowSelect = True
        ListView1.Columns.Add("Name", 250)
        ListView1.Columns.Add("Type", 100)
        initializing()
    End Sub
    Private Sub initializing()
        numberkey = 0
        tfsUri = New Uri("http://" & serverName & ":8080/tfs")
        configurationServer = TfsConfigurationServerFactory.GetConfigurationServer(tfsUri)
        ' Get the catalog of team project collections
        Dim gVar As Guid() = New Guid() {CatalogResourceTypes.ProjectCollection}

        Dim Row As DataRow = Report.NewRow
        'Add some data to it
        Row("Report_Type") = LocRM.GetString("reportServer") & serverName
        'Add it to the table
        Report.Rows.Add(Row)

        collectionNodes = configurationServer.CatalogNode.QueryChildren(gVar, False, CatalogQueryOptions.None)
        ' List the team project collections
        For Each collectionNode In collectionNodes
            Try
                Dim collectionId As Guid = New Guid(collectionNode.Resource.Properties("InstanceID"))

                Dim teamProjectCollection As New TfsTeamProjectCollection(tfsUri)

                teamProjectCollection = configurationServer.GetTeamProjectCollection(collectionId)
                teamProjectCollectionGroup = teamProjectCollection.Name
                Dim tfs As TfsTeamProjectCollection = _
                        TfsTeamProjectCollectionFactory.GetTeamProjectCollection( _
                          New Uri("http://" & serverName & ":8080/tfs/" & splitingLast(teamProjectCollection.Name)))
                tfs.EnsureAuthenticated()
                '    // Group Security service exposes methods to get groups, users and security details
                sec = tfs.GetService(Of IIdentityManagementService)()

                '    // Version control service exposes methods to work with TFS version control
                vcs = tfs.GetService(Of VersionControlServer)()

                '    // Since we'll be reporting groups for all team projects, imp to get all team projects
                Dim teamProjects() As TeamProject = vcs.GetAllTeamProjects(False)

                For Each projects In teamProjects
                    project = projects
                    appGroups = _
                               sec.ListApplicationGroups(project.ArtifactUri.AbsoluteUri, ReadIdentityOptions.TrueSid)

                    ListV()
                Next
            Catch ex As Exception
                MessageBox.Show(LocRM.GetString("Error_CollectionUnavailable") & ": " & teamProjectCollectionGroup, _
                                "Alert Notice", _
                                MessageBoxButtons.OK, _
                                MessageBoxIcon.Exclamation, _
                                MessageBoxDefaultButton.Button1)
            End Try

        Next


    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        'closes the form
        MainPage.Enabled = True
        MainPage.Focus()
        Me.Close()
    End Sub

    Private Sub ListV()
        'gets all the groups and user working within the projects selected
        'puts all information in the listview, a sortedList and Dataset
        Dim g As String
        For Each group In appGroups
            Dim lstGroup As New ListViewGroup
            g = group.DisplayName.ToString
            lstGroup.HeaderAlignment = HorizontalAlignment.Left
            lstGroup.Header = g
            ListView1.Groups.Add(lstGroup)

            Dim b As String = group.DisplayName.ToString
            groupMembers = sec.ReadIdentity(searchFactor:=IdentitySearchFactor.AccountName, _
            searchFactorValue:=b, queryMembership:=MembershipQuery.Direct, readOptions:=ReadIdentityOptions.TrueSid)

            nodeMembers = sec.ReadIdentities(groupMembers.Members, MembershipQuery.Expanded, _
                                                 ReadIdentityOptions.TrueSid)
            For Each m In nodeMembers
                Dim lstItem As New ListViewItem
                Dim newRow2 As DataRow = t.NewRow
                newRow2("Name") = m.DisplayName
                lstItem.Text = m.DisplayName
                lstItem.Group = lstGroup
                lstItem.ImageIndex = 0
                If m.IsContainer Then
                    lstItem.BackColor = Color.AliceBlue
                    lstItem.SubItems.Add("Group")
                    newRow2("Type") = "Groups"
                    newRow2("Group") = lstGroup.ToString
                Else
                    lstItem.SubItems.Add("User")
                    newRow2("Type") = "User"
                    newRow2("Group") = lstGroup.ToString
                End If
                ListView1.Items.Add(lstItem)

                'Add it to the table
                t.Rows.Add(newRow2)
                Addpermission(m.DisplayName.ToString)



                If m.IsContainer Then

                    Dim mMember() As TeamFoundationIdentity = sec.ReadIdentities(m.Members, MembershipQuery.Expanded, _
                                                 ReadIdentityOptions.TrueSid)
                    For Each gMember In mMember
                        Dim lstItemg As New ListViewItem
                        lstItemg.Text = " -    " & gMember.DisplayName
                        lstItemg.BackColor = Color.AliceBlue
                        lstItemg.Group = lstGroup
                        lstItemg.ImageIndex = 1
                        lstItemg.SubItems.Add("Group User")
                        ListView1.Items.Add(lstItemg)

                        Dim newRow As DataRow = t.NewRow

                        'Add some data to it
                        newRow("Name") = " -    " & gMember.DisplayName
                        newRow("Type") = "Group User"
                        newRow("Group") = lstGroup.ToString
                        'Add it to the table
                        t.Rows.Add(newRow)

                        Addpermission(gMember.DisplayName.ToString)

                    Next
                End If

            Next
        Next

    End Sub
    Private Function NUserName(ByVal name As String) As String
        'gets the membre's username
        Dim a As String = name
        Dim myConnection As New SqlConnection("Data Source=" & ServerData & ";Initial Catalog=Tfs_" & splitingLast(UserPermissions.Item(ListView1.SelectedIndices(0)).Collection) & ";Integrated Security=True")
        Dim myCommand As New SqlCommand("SELECT [NamePart] FROM [dbo].[Constants] where [DisplayPart] = '" & a & "'")
        myCommand.Connection = myConnection
        myConnection.Open()
        Dim user As String = Convert.ToString(myCommand.ExecuteScalar())
        myCommand.Connection.Close()
        Return user
    End Function

    Private Sub ListView1_ItemSelectionChanged(ByVal sender As Object, ByVal e As System.Windows.Forms.ListViewItemSelectionChangedEventArgs) Handles ListView1.ItemSelectionChanged
        'when the user selects a membre in the list view
        'it will go get in tfs all the permissions that the membre has in the project
        'through the sortedlist
        Try
            ListBox1.Items.Clear()
            If ListView1.SelectedIndices.Count <> 0 Then
                Dim userName As String = NUserName(UserPermissions.Item(ListView1.SelectedItems(0).Index.ToString).Name)
                Dim permissions = _
                    UserPermissions.Item(ListView1.SelectedItems(0).Index.ToString).vcs.GetEffectivePermissions(userName, UserPermissions.Item(ListView1.SelectedItems(0).Index.ToString).project.ServerItem)
                Dim actualPermission = _
                        UserPermissions.Item(ListView1.SelectedItems(0).Index.ToString).vcs.GetPermissions(New String() {project.ServerItem}, _
                                        RecursionType.Full)

                For Each permission In permissions
                    ListBox1.Items.Add(permission.ToString)
                Next
            End If

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Public Function splitingLast(ByVal change As String) As String

        'this function returns the collection name for getting the database
        'ex: ncr**2**\DefaultCollection = DefaultCollection
        'ex2: //http:/ncr**2**/DefaultCollection = DefaultCollection

        Dim local As String() = change.Split(New Char() {"\"c})
        Dim hyperlink As String() = change.Split(New Char() {"/"c})
        ' Loop through result strings with For Each
        Dim part As String

        If (local.Length = 1) Then
            part = hyperlink(hyperlink.Length - 1)
        Else
            part = local(local.Length - 1)
        End If

        Return part

    End Function
    Private Sub Addpermission(ByRef name As String)
        'Get all the requirements in a Dictionary to get the permission
        Dim perm As New Permissions
        perm.sec = sec
        perm.vcs = vcs
        perm.project = project
        perm.Collection = teamProjectCollectionGroup
        perm.Name = name
        Try
            UserPermissions.Add(numberkey, perm)
        Catch ex As Exception

        End Try

        numberkey = numberkey + 1
    End Sub

    Private Sub ButtonPrintListView_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonPrintListView.Click
        'shows the form for the crystal report
        Dim cv As CrystalViewer
        cv = New CrystalViewer()
        cv.Show()
        Dim objRpt As New CrystalReport1
        objRpt.SetDataSource(ds)
        cv.CrystalReportViewer1.ReportSource = objRpt
        cv.CrystalReportViewer1.Zoom(2)
        cv.CrystalReportViewer1.Refresh()
        cv = Nothing


    End Sub

End Class

Public Class Permissions
    Public Name As String
    Public Collection As String
    Public project As TeamProject
    Public sec As IIdentityManagementService
    Public vcs As VersionControlServer
End Class