﻿Imports System.Data
Imports System.Data.SqlClient
Imports Microsoft.TeamFoundation.Client
Imports Microsoft.TeamFoundation.Framework.Common
Imports Microsoft.TeamFoundation.Framework.Client
Imports Microsoft.TeamFoundation.Common
Imports Microsoft.TeamFoundation.VersionControl.Client
Imports System.Globalization
Imports System.Threading
Imports CrystalDecisions.Shared
Imports CrystalDecisions.CrystalReports.Engine
Imports System.Resources

Public Class reprotTfsProject

    Private projectName As String
    Private selection As String
    Private ProjectCollection As String
    Private serverName As String
    Private ServerData As String
    Private GGMember As TeamFoundationIdentity

    Dim ds As New DataSet1
    Dim t As DataTable = ds.DataTable1
    Dim Report As DataTable = ds.Report_Info

    Dim project As TeamProject
    Dim sec As IIdentityManagementService
    Dim vcs As VersionControlServer
    Dim appGroups() As TeamFoundationIdentity
    Dim groupMembers As TeamFoundationIdentity
    Dim nodeMembers() As TeamFoundationIdentity

    Dim LocRM As New ResourceManager("RenamingTool.Resource", GetType(MainPage).Assembly)


    Private Sub reprotTfsProject_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'when form loads
        'it gets all information required from whatever treenode the user chooses
        'creates the listview
        selection = MainPage.getSelection
        MainPage.Enabled = False
        If selection = "Project" Then
            projectName = MainPage.getProjectName
            ProjectCollection = MainPage.getCollectionName
            serverName = MainPage.getServerName
            ServerData = MainPage.getDataTierName
        ElseIf selection = "Collection" Then
            ProjectCollection = MainPage.getCollectionNameFromCollection
            serverName = MainPage.getServerNameFromCollection
            ServerData = MainPage.getDataTierName
        End If
        If MainPage.langFra Then
            Thread.CurrentThread.CurrentUICulture = New CultureInfo("fr-CA")
        Else
            Thread.CurrentThread.CurrentUICulture = New CultureInfo("en-CA")
        End If

        Label1.Text = LocRM.GetString("Report.Label1")
        Label2.Text = LocRM.GetString("Report.Label2")
        btnPrint.Text = LocRM.GetString("Report.BtnPrint")
        Button1.Text = LocRM.GetString("Report.btnClose")

        ListView1.View = View.Details
        ListView1.FullRowSelect = True
        ListView1.Columns.Add("Name", 250)
        ListView1.Columns.Add("Type", 100)
        initializing()
    End Sub
    Private Sub initializing()
        'http://www.codeproject.com/Articles/262673/TFS-SDK-Get-Groups-Users-Permissions-using-TFS-API
        Dim tfs = _
        TfsTeamProjectCollectionFactory.GetTeamProjectCollection( _
          New Uri("http://" & serverName & ":8080/tfs/" & ProjectCollection))
        Try
            tfs.EnsureAuthenticated()
            '    // Group Security service exposes methods to get groups, users and security details
            sec = tfs.GetService(Of IIdentityManagementService)()

            '    // Version control service exposes methods to work with TFS version control
            vcs = tfs.GetService(Of VersionControlServer)()

            '    // Since we'll be reporting groups for all team projects, imp to get all team projects
            Dim teamProjects() As TeamProject = vcs.GetAllTeamProjects(False)
            If selection = "Project" Then

                Dim Row As DataRow = Report.NewRow
                'Add some data to it
                Row("Report_Type") = LocRM.GetString("reportProject") & projectName
                'Add it to the table
                Report.Rows.Add(Row)

                For Each projects In teamProjects
                    project = projects
                    If (project.Name = projectName) Then
                        appGroups = _
                           sec.ListApplicationGroups(project.ArtifactUri.AbsoluteUri, ReadIdentityOptions.TrueSid)

                        ListV()
                    End If
                Next
            ElseIf selection = "Collection" Then

                Dim Row As DataRow = Report.NewRow
                'Add some data to it
                Row("Report_Type") = LocRM.GetString("reportCollection") & ProjectCollection
                'Add it to the table
                Report.Rows.Add(Row)

                For Each projects In teamProjects
                    project = projects
                    appGroups = _
                               sec.ListApplicationGroups(project.ArtifactUri.AbsoluteUri, ReadIdentityOptions.TrueSid)

                    ListV()
                Next

            End If
        Catch ex As Exception
            MessageBox.Show(LocRM.GetString("Error_CollectionUnavailable") & ": " & ProjectCollection, _
                                "Alert Notice", _
                                MessageBoxButtons.OK, _
                                MessageBoxIcon.Exclamation, _
                                MessageBoxDefaultButton.Button1)
        End Try



    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        MainPage.Enabled = True
        MainPage.Focus()
        Me.Close()
    End Sub

    Private Sub ListV()
        'gets all the groups and user working within the projects selected
        'puts all information in the listview and Dataset
        Dim g As String
        For Each group In appGroups
            Dim lstGroup As New ListViewGroup
            g = group.DisplayName.ToString
            lstGroup.HeaderAlignment = HorizontalAlignment.Left
            lstGroup.Header = g
            ListView1.Groups.Add(lstGroup)

            Dim b As String = group.DisplayName.ToString
            groupMembers = sec.ReadIdentity(searchFactor:=IdentitySearchFactor.AccountName, _
            searchFactorValue:=b, queryMembership:=MembershipQuery.Direct, readOptions:=ReadIdentityOptions.None)

            nodeMembers = sec.ReadIdentities(groupMembers.Members, MembershipQuery.Direct, _
                                                 ReadIdentityOptions.TrueSid)
            For Each m In nodeMembers
                Dim lstItem As New ListViewItem
                Dim newRow2 As DataRow = t.NewRow
                newRow2("Name") = m.DisplayName
                lstItem.Text = m.DisplayName
                lstItem.Group = lstGroup
                lstItem.ImageIndex = 0
                If m.IsContainer Then
                    lstItem.BackColor = Color.AliceBlue
                    lstItem.SubItems.Add("Group")
                    newRow2("Type") = "Group"
                    newRow2("Group") = lstGroup.ToString
                Else
                    lstItem.SubItems.Add("User")
                    newRow2("Type") = "User"
                    newRow2("Group") = lstGroup.ToString
                End If
                ListView1.Items.Add(lstItem)
                t.Rows.Add(newRow2)


                If m.IsContainer Then

                    Dim mMember() As TeamFoundationIdentity = sec.ReadIdentities(m.Members, MembershipQuery.Expanded, _
                                                 ReadIdentityOptions.TrueSid)
                    For Each gMember In mMember
                        Dim lstItemg As New ListViewItem
                        lstItemg.Text = " -    " & gMember.DisplayName
                        lstItemg.BackColor = Color.AliceBlue
                        lstItemg.Group = lstGroup
                        lstItemg.SubItems.Add("Group User")
                        lstItemg.ImageIndex = 1
                        ListView1.Items.Add(lstItemg)

                        Dim newRow As DataRow = t.NewRow

                        newRow("Name") = " -    " & gMember.DisplayName
                        newRow("Type") = "Group User"
                        newRow("Group") = lstGroup.ToString

                        t.Rows.Add(newRow)
                    Next
                End If

            Next
        Next

    End Sub

    Private Function NUserName(ByVal name As String) As String
        'gets the membre's username
        Dim a As String = name
        Dim myConnection As New SqlConnection("Data Source=" & ServerData & ";Initial Catalog=Tfs_" & ProjectCollection & ";Integrated Security=True")
        Dim myCommand As New SqlCommand("SELECT [NamePart] FROM [dbo].[Constants] where [DisplayPart] = '" & a & "'")
        myCommand.Connection = myConnection
        myConnection.Open()
        Dim user As String = Convert.ToString(myCommand.ExecuteScalar())
        myCommand.Connection.Close()
        Return user
    End Function

    Private Sub ListView1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListView1.SelectedIndexChanged
        'when the user selects a membre in the list view
        'it will go get in tfs all the permissions that the membre has in the project
        Try
            If ListView1.SelectedItems.Count <> 0 Then
                Dim i As String
                i = ListView1.SelectedItems(0).Text
                If ListView1.SelectedItems(0).SubItems(1).Text = "Group User" Then
                    i = i.Substring(3)
                    i = i.Trim()
                End If

                Dim userName As String = NUserName(i)

                Dim permissions = _
                    vcs.GetEffectivePermissions(userName, project.ServerItem)
                Dim actualPermission = _
                        vcs.GetPermissions(New String() {project.ServerItem}, _
                                        RecursionType.Full)
                ListBox1.Items.Clear()
                For Each permission In permissions
                    ListBox1.Items.Add(permission.ToString)
                Next
            End If

        Catch ex As Exception

        End Try

    End Sub

    Private Sub btnPrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrint.Click
        'shows the form for the crystal report
        Dim cv As CrystalViewer
        cv = New CrystalViewer()
        cv.Show()
        Dim objRpt As New CrystalReport1
        objRpt.SetDataSource(ds)
        cv.CrystalReportViewer1.ReportSource = objRpt
        cv.CrystalReportViewer1.Zoom(2)
        cv.CrystalReportViewer1.Refresh()
        cv = Nothing
    End Sub
End Class

